<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
<div class="container">
  <h2>Registration Car Form</h2>

  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="country-select">Country</label>
      </div>
      <div class="col-sm-3">
        <select id="country-select" name="country" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="region-type-select">Region</label>
      </div>
      <div class="col-sm-3">
        <select id="region-type-select" name="region" class="form-control">
        </select>
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3">
        <label for="car-type-select">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button class="btn btn-info" id="btn-send"> Send </button>
      </div>
    </div>
  </div>
</div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;
  
  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;
  
  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryData = JSON.parse(gJsonCountryData); //Task30.30
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function(){
    onPageLoading();
  });
  //subtask2: thêm sự kiện change cho select car
  $("#car-select").on("change",function(){
    onCarSelectChange(this);
  })
  $("#country-select").on("change",function(){ //Task30.30
    onCountrySelectChange(this);
  })

  //subtask4: thêm sự kiện click nút send
  $("#btn-send").click(function(){
    onBtnSendClick();
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý sự kiện load trang
  function onPageLoading(){
    loadDataToSelectCar(); //subtask 1
    loadDataToSelectCountry(); //Task30.30 subtask 1
  }
  //hàm xử lý sự kiện change car select
  function  onCarSelectChange(paramCarSelect){
    var vBrandId = $(paramCarSelect).val();
    console.log(vBrandId);
    //load dữ liệu ra car type
    loadDataToSelectCarType(vBrandId);
  }
  //hàm xử lý sự kiện change country select
  function  onCountrySelectChange(paramCountrySelect){
    var vCountryId = $(paramCountrySelect).val();
    console.log(vCountryId);
    //load dữ liệu ra region
    loadDataToSelectRegion(vCountryId);
  }
  //hàm xử lý sự kiện bấm nút send
  function onBtnSendClick(){
    //b1: khai báo biến và thu thập dữ liệu
    var vRegistrationCarObj = {
      brandId: -1,
      brandName: "",
      typeId: -1,
      typeName: "",
      countryId: -1, //thêm các tham số cho biến lưu thông tin đăng ký ô tô
      countryName:"",
      regionId: -1,
      regionName: ""
    }
    getRegistrationCarObjData(vRegistrationCarObj);
    //b2: kiểm tra dữ liệu
    var vValid = validateData(vRegistrationCarObj);
    //b3: hiển thị dữ liệu
    if (vValid){
      sendCarData(vRegistrationCarObj);
    }
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm load dữ liệu vào select car
  function loadDataToSelectCar(){
    var vCarSelect = $("#car-select");
    for (var bI = 0; bI < gObjectCarData.length; bI++){
      $("<option/>",{
        "value" : gObjectCarData[bI].brandId,
        "text" : gObjectCarData[bI].brandName
      }).appendTo(vCarSelect);
    }
  }
  //hàm load dữ liệu lên select car type
  function loadDataToSelectCarType(paramBrandId){
    //load dữ liệu brand type
    var vBrandType = getBrandTypeByBrandID(paramBrandId);
    var vCarTypeSelect = $("#car-type-select");
    //reset select car type
    $(vCarTypeSelect).html("");
    //set enable/disable cho select car type element
    if(vBrandType.length == 0){
      $(vCarTypeSelect).prop("disabled","disabled");
    } else {$(vCarTypeSelect).prop("disabled",false);
    }
    //load dữ liệu
    for (var bI=0; bI<vBrandType.length; bI++){
      $("<option/>",{
        "value": vBrandType[bI].typeId,
        "text" :vBrandType[bI].typeName
      }).appendTo(vCarTypeSelect);
    }
  }
  //Task 30.30 hàm load dữ liệu vào select country
  function loadDataToSelectCountry(){
    var vCountrySelect = $("#country-select");
    for (var bI = 0; bI < gObjectCountryData.length; bI++){
      $("<option/>",{
        "value" : gObjectCountryData[bI].countryId,
        "text" : gObjectCountryData[bI].countryName
      }).appendTo(vCountrySelect);
    }
  }
  //Task30.30 hàm load dữ liệu lên select region
  function loadDataToSelectRegion(paramCountryId){
    //load dữ liệu region
    var vRegion = getRegionByCountryId(paramCountryId);
    var vRegionTypeSelect = $("#region-type-select");
    //reset select car type
    $(vRegionTypeSelect).html("");
    //set enable/disable cho select region element
    if(vRegion.length == 0){
      $(vRegionTypeSelect).prop("disabled","disabled");
    } else {$(vRegionTypeSelect).prop("disabled",false);
    }
    //load dữ liệu
    for (var bI=0; bI<vRegion.length; bI++){
      $("<option/>",{
        "value": vRegion[bI].regionId,
        "text" :vRegion[bI].regionName
      }).appendTo(vRegionTypeSelect);
    }
  }
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
        if (gObjectCarData[vIterator].brandId === paramBrandId) {
          vBrandFound = true;
          vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vBrandTypesResult;
  }
  //get Region by country Id
  function getRegionByCountryId(paramCountryId) {
    var vRegionFound = false;
    var vRegionTypesResult = null;
    var vIterator = 0;
    while (!vRegionFound && vIterator < gObjectCountryData.length) {
        if (gObjectCountryData[vIterator].countryId === paramCountryId) {
          vRegionFound = true;
          vRegionTypesResult = gObjectCountryData[vIterator].regionTypes;
        }
        else {
          vIterator ++;
        }
    }
    return vRegionTypesResult;
  }
//hàm thu thập dữ liệu trên form
function getRegistrationCarObjData(paramRegistrationCarObj){
  paramRegistrationCarObj.brandId = $("#car-select").val();
  paramRegistrationCarObj.brandName = $("#car-select option:selected").text();
  paramRegistrationCarObj.typeId = $("#car-type-select").val();
  paramRegistrationCarObj.typeName = $("#car-type-select option:selected").text();
  paramRegistrationCarObj.countryId = $("#country-select").val();
  paramRegistrationCarObj.countryName = $("#country-select option:selected").text();
  paramRegistrationCarObj.regionId = $("#region-type-select").val();
  paramRegistrationCarObj.regionName = $("#region-type-select option:selected").text();
}
//hàm kiểm tra dữ liệu trên form
function validateData(paramRegistrationCarObj){
  if (paramRegistrationCarObj.brandId == 0){
    alert ("Phải chọn car brand");
    $("#car-select").focus();
    return false;
  }
  if (paramRegistrationCarObj.typeId == -1){
    alert ("Phải chọn car type");
    $("#car-type-select").focus();
    return false;
  }
  if (paramRegistrationCarObj.countryId == 0){
    alert ("Phải chọn country");
    $("#country-select").focus();
    return false;
  }
  if (paramRegistrationCarObj.regionId == -1){
    alert ("Phải chọn region");
    $("#region-type-select").focus();
    return false;
  }
  return true;
};
//hàm gửi dữ liệu
function sendCarData(paramRegistrationCarObj){
  console.log(paramRegistrationCarObj);
}
</script> 

</html>